/*
	rpipic - A PIC Programmer for the Raspberry Pi
	Copyright (C) 2012  Nicholas Tomlinson
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>. 
*/


#ifndef PIC12_HPP
#define PIC12_HPP

#include <stdint.h>
#include "pic.hpp"

struct Pic12BitChip;
class Pic12Bit : public Pic
{
	public:
		Pic12Bit(Board &board, const char *name);
		virtual ~Pic12Bit();
		
		virtual void PrintMeta(Data &data);
		
		virtual void ReadProgram(Data &data);
		virtual void ReadData(Data &data);
		virtual void ReadConfiguration(Data &data);
		virtual void ReadUserId(Data &data);
		virtual void ReadDeviceId(Data &data); //Does nothing
		
		virtual void WriteProgram(Data &data);
		virtual void WriteData(Data &data);
		virtual void WriteConfiguration(Data &data);
		virtual void WriteUserId(Data &data);
		
		virtual void Erase();
		
	private:
		static const Pic12BitChip &GetChip(const char *name);
		
		static const Pic12BitChip s_chips[];
		
		const Pic12BitChip &m_chip;
};

#endif

