/*
	rpipic - A PIC Programmer for the Raspberry Pi
	Copyright (C) 2012  Nicholas Tomlinson
	
	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>. 
*/


#ifndef PIC14_HPP
#define PIC14_HPP

#include <stdint.h>
#include "pic.hpp"

struct Pic14BitChip;
class Pic14Bit : public Pic
{
	public:
		Pic14Bit(Board &board);
		
		virtual void PrintMeta(Data &data);
		
		virtual void ReadProgram(Data &data);
		virtual void ReadData(Data &data);
		virtual void ReadConfiguration(Data &data);
		virtual void ReadUserId(Data &data);
		virtual void ReadDeviceId(Data &data);
		
		virtual void WriteProgram(Data &data);
		virtual void WriteData(Data &data);
		virtual void WriteConfiguration(Data &data);
		virtual void WriteUserId(Data &data);
		
		virtual void Erase();
		
	private:
		static const Pic14BitChip *GetChip(uint16_t word, bool error = false);
		void BulkEraseSetup();
		uint16_t GetDeviceId();
		
		const Pic14BitChip *m_chip;
		
		static const Pic14BitChip s_chips[];
};

#endif

